src/Entity/Candidate.php
<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="App\Repository\CandidateRepository")
 */
class Candidate
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $firstname;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $lastname;

    /**
     * @ORM\Column(type="date")
     */
    private $date_of_birth;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $address;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $postal_code;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $city;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $phone;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $school;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $diploma;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $year_graduation;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $description;

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\User", inversedBy="candidate", cascade={"persist", "remove"})
     * @ORM\JoinColumn(nullable=false)
     */
    private $user;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstname(): ?string
    {
        return $this->firstname;
    }

    public function setFirstname(string $firstname): self
    {
        $this->firstname = $firstname;

        return $this;
    }

    public function getLastname(): ?string
    {
        return $this->lastname;
    }

    public function setLastname(string $lastname): self
    {
        $this->lastname = $lastname;

        return $this;
    }

    public function getDateOfBirth(): ?\DateTimeInterface
    {
        return $this->date_of_birth;
    }

    public function setDateOfBirth(\DateTimeInterface $date_of_birth): self
    {
        $this->date_of_birth = $date_of_birth;

        return $this;
    }

    public function getAddress(): ?string
    {
        return $this->address;
    }

    public function setAddress(string $address): self
    {
        $this->address = $address;

        return $this;
    }

    public function getPostalCode(): ?string
    {
        return $this->postal_code;
    }

    public function setPostalCode(string $postal_code): self
    {
        $this->postal_code = $postal_code;

        return $this;
    }

    public function getCity(): ?string
    {
        return $this->city;
    }

    public function setCity(string $city): self
    {
        $this->city = $city;

        return $this;
    }

    public function getPhone(): ?string
    {
        return $this->phone;
    }

    public function setPhone(?string $phone): self
    {
        $this->phone = $phone;

        return $this;
    }

    public function getSchool(): ?string
    {
        return $this->school;
    }

    public function setSchool(?string $school): self
    {
        $this->school = $school;

        return $this;
    }

    public function getDiploma(): ?string
    {
        return $this->diploma;
    }

    public function setDiploma(?string $diploma): self
    {
        $this->diploma = $diploma;

        return $this;
    }

    public function getYearGraduation(): ?int
    {
        return $this->year_graduation;
    }

    public function setYearGraduation(?int $year_graduation): self
    {
        $this->year_graduation = $year_graduation;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(User $user): self
    {
        $this->user = $user;

        return $this;
    }
}

src/Entity/Company.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="App\Repository\CompanyRepository")
 */
class Company
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $company_name;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $company_type;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $address;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $postal_code;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $city;

    /**
     * @ORM\Column(type="integer")
     */
    private $nb_employees;

    /**
     * @ORM\Column(type="integer")
     */
    private $year_creation;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $inter_presence;

    /**
     * @ORM\Column(type="text")
     */
    private $general_description;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $values_description;

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\User", inversedBy="company", cascade={"persist", "remove"})
     * @ORM\JoinColumn(nullable=false)
     */
    private $user;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Offer", mappedBy="company", orphanRemoval=true)
     */
    private $offers;

    public function __construct()
    {
        $this->offers = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getCompanyName(): ?string
    {
        return $this->company_name;
    }

    public function setCompanyName(string $company_name): self
    {
        $this->company_name = $company_name;

        return $this;
    }

    public function getCompanyType(): ?string
    {
        return $this->company_type;
    }

    public function setCompanyType(string $company_type): self
    {
        $this->company_type = $company_type;

        return $this;
    }

    public function getAddress(): ?string
    {
        return $this->address;
    }

    public function setAddress(string $address): self
    {
        $this->address = $address;

        return $this;
    }

    public function getPostalCode(): ?string
    {
        return $this->postal_code;
    }

    public function setPostalCode(string $postal_code): self
    {
        $this->postal_code = $postal_code;

        return $this;
    }

    public function getCity(): ?string
    {
        return $this->city;
    }

    public function setCity(string $city): self
    {
        $this->city = $city;

        return $this;
    }

    public function getNbEmployees(): ?int
    {
        return $this->nb_employees;
    }

    public function setNbEmployees(int $nb_employees): self
    {
        $this->nb_employees = $nb_employees;

        return $this;
    }

    public function getYearCreation(): ?int
    {
        return $this->year_creation;
    }

    public function setYearCreation(int $year_creation): self
    {
        $this->year_creation = $year_creation;

        return $this;
    }

    public function getInterPresence(): ?string
    {
        return $this->inter_presence;
    }

    public function setInterPresence(string $inter_presence): self
    {
        $this->inter_presence = $inter_presence;

        return $this;
    }

    public function getGeneralDescription(): ?string
    {
        return $this->general_description;
    }

    public function setGeneralDescription(string $general_description): self
    {
        $this->general_description = $general_description;

        return $this;
    }

    public function getValuesDescription(): ?string
    {
        return $this->values_description;
    }

    public function setValuesDescription(?string $values_description): self
    {
        $this->values_description = $values_description;

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(User $user): self
    {
        $this->user = $user;

        return $this;
    }

    /**
     * @return Collection|Offer[]
     */
    public function getOffers(): Collection
    {
        return $this->offers;
    }

    public function addOffer(Offer $offer): self
    {
        if (!$this->offers->contains($offer)) {
            $this->offers[] = $offer;
            $offer->setCompany($this);
        }

        return $this;
    }

    public function removeOffer(Offer $offer): self
    {
        if ($this->offers->contains($offer)) {
            $this->offers->removeElement($offer);
            // set the owning side to null (unless already changed)
            if ($offer->getCompany() === $this) {
                $offer->setCompany(null);
            }
        }

        return $this;
    }
}

src/Controller/ProfileController.php
<?php

namespace App\Controller;

use App\Entity\User;
use App\Entity\Offer;
use App\Entity\Company;
use App\Form\OfferType;
use App\Entity\Candidate;
use App\Form\CompanyType;
use App\Form\CandidateType;
use App\Form\RegistrationType;
use Symfony\Component\HttpFoundation\Request;
use Doctrine\Common\Persistence\ObjectManager;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\HttpFoundation\Session\SessionInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;


class ProfileController extends AbstractController
{
    /**
     * @Route("/profile", name="profile_index")
     */
    public function showProfile() {
        return $this->render('profile/index.html.twig');
    }

    /**
     * @Route("/profile/edit", name="profile_edit")
     */    
    public function editProfile(UserInterface $user = null, Candidate $candidate = null, Company $company = null, SessionInterface $session, Request $request, ObjectManager $manager)
    {
        if($user->getCandidate() != null) {
            $candidate = $user->getCandidate();
            $form = $this->createForm(CandidateType::class, $candidate);
        } else if($user->getCompany() != null) {
            $company = $user->getCompany();
            $form = $this->createForm(CompanyType::class, $company);
        }

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            if($candidate = $user->getCandidate()) {
                $manager->persist($candidate);
            } else if($company = $user->getCandidate()) {
                $manager->persist($company);
            }
            $manager->flush();

            $this->addFlash('success', 'Votre profil a bien été mis à jour');
            return $this->redirectToRoute('profile_index');
        }

        return $this->render('profile/profile.edit.html.twig', [
            'form' => $form->createView()
        ]);
    } 

    /**
     * @Route("/profile/offers-fav", name="profile_offers_fav")
     */
    public function showOffersFav() {
        return $this->render('profile/candidate/profile.fav.html.twig');
    }

    /**
     * @Route("/profile/appli-sent", name="profile_appli_sent")
     */
    public function showAppliSent() {
        return $this->render('profile/candidate/profile.sent.html.twig');
    }

    /**
     * @Route("/profile/offers-created", name="profile_offers_created")
     */
    public function showOffersCreated() {
        return $this->render('profile/company/profile.created.html.twig');
    }

    /**
     * @Route("/profile/appli-received", name="profile_appli_received")
     */
    public function showAppliReceived() {
        return $this->render('profile/company/profile.received.html.twig');
    }
}

templates/profile/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Profil{% endblock %}

{% block body %}
<div class="container">
    <div class="row">
        {% include 'block/profile.block.html.twig' %}
        <div class="col-9">
            <div class="container">
                {% if user.candidate is defined and user.candidate is not null %}
                <div class="row">
                    <div class="col">
                        <h1>Profil</h1>
                        <span class="d-block">Prénom : {{ user.candidate.firstName }}</span>
                        <span class="d-block">Nom : {{ user.candidate.lastName }}</span>
                        <p class="lead">Description : {{ user.candidate.description }}</p>
                        <span class="d-block">Âge :</span>
                        <span class="d-block">Adresse : {{ user.candidate.address }} {{ user.company.postalCode }} {{ user.candidate.city }}</span>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <h3>Formation</h3>
                        <span class="d-block">École/Université : {{ user.candidate.school }}</span>
                        <span class="d-block">Diplôme en cours : {{ user.candidate.diploma }}</span>               
                        <span class="d-block">Année d'obtention : {{ user.candidate.yearGraduation }}</span>               
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <h3>Compte</h3>
                        <span class="d-block">Adresse mail : {{ user.email }}</span>
                        <span class="d-block">Téléphone : {{ user.candidate.phone }}</span>
                    </div>
                </div>
                
                {% elseif user.company is defined and user.company is not null %}
                <div class="row">
                    <div class="col">
                        <h1>Profil</h1>
                        <span class="d-block">Nom : {{ user.company.companyName }}</span>
                        <span class="d-block">Adresse : {{ user.company.address }} {{ user.company.postalCode }} {{ user.company.city }}</span>
                        <p class="lead">Description : {{ user.company.generalDescription | raw }}</p>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <h3>Caractéristiques</h3>
                        <span class="d-block">Type : {{ user.company.companyType }}</span>
                        <span class="d-block">Nombre d'employés : {{ user.company.nbEmployees }}</span>               
                        <span class="d-block">Année de création : {{ user.company.yearCreation }}</span>               
                        <span class="d-block">Présence à l'international : {{ user.company.interPresence }}</span>               
                        <p class="lead">Valeurs / Culture : {{ user.company.valuesDescription | raw }}</p>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <h3>Compte</h3>
                        <span class="d-block">Adresse mail : {{ user.email }}</span>
                    </div>
                </div>
                {% endif %}
            </div>
        </div>
    </div>
</div>

{% endblock %}

templates/profile/profile.edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Profil{% endblock %}

{% block body %}
<div class="container">
    <div class="row">
        {% include 'block/profile.block.html.twig' %}
        <div class="col-9">
            {{ form_start(form) }}
            {{ form_widget(form) }}
            <button type="submit" class="btn btn-success">Mettre à jour</button>
            {{ form_end(form) }}
            </div>
        </div>
    </div>
</div>

{% endblock %}